'use strict';

var t = require('@babel/types');
var findBindings = require('./findBindings.js');

function _interopNamespaceDefault(e) {
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var t__namespace = /*#__PURE__*/_interopNamespaceDefault(t);

function isTaddy(binding) {
    const { path } = binding;
    if (!path.isImportSpecifier())
        return false;
    const { imported } = path.node;
    return (t__namespace.isIdentifier(imported) &&
        ((path.parentPath.node.source
            .value === 'taddy' &&
            imported.name === 'css') ||
            imported.name === 'mixin'));
}
class BindingOptimizer {
    cache = new Map();
    process(referentPath) {
        let bindings;
        try {
            bindings = findBindings.findBindings(referentPath);
        }
        catch (error) {
            return;
        }
        for (const [binding, paths] of bindings) {
            if (isTaddy(binding))
                continue;
            if (binding.path.removed)
                continue;
            this.process(binding.path);
            findBindings.addBinding(this.cache, binding, paths);
            if (this.cache.get(binding).size < binding.references) {
                continue;
            }
            binding.path.remove();
            const { parentPath } = binding.path;
            const isImportToRemove = parentPath?.isImportDeclaration() &&
                parentPath.node.specifiers.length === 0;
            // // keep imports for development build
            // if (env === 'development') {
            //     return;
            // }
            if (!isImportToRemove) {
                continue;
            }
            parentPath.remove();
        }
    }
}

exports.BindingOptimizer = BindingOptimizer;
//# sourceMappingURL=BindingOptimizer.js.map
