'use strict';

var t = require('@babel/types');

function _interopNamespaceDefault(e) {
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var t__namespace = /*#__PURE__*/_interopNamespaceDefault(t);

function mergeObjectProperties(properties) {
    const map = new Map();
    function move(key, value) {
        map.delete(key);
        map.set(key, value);
    }
    for (const x of properties) {
        if (!t__namespace.isObjectProperty(x)) {
            move(x, x);
            continue;
        }
        const { key } = x;
        if (t__namespace.isIdentifier(key)) {
            move(key.name, x);
            continue;
        }
        if (t__namespace.isStringLiteral(key)) {
            move(key.value, x);
            continue;
        }
        move(x, x);
    }
    // TODO: there was a problem with typescript compiler with the variant [...map.values()]
    return Array.from(map.values());
}
function mergeObjects(objects) {
    const properties = [];
    objects.forEach((obj) => {
        properties.push(...obj.properties);
    });
    return mergeObjectProperties(properties);
}

exports.mergeObjectProperties = mergeObjectProperties;
exports.mergeObjects = mergeObjects;
//# sourceMappingURL=mergeObjectProperties.js.map
