'use strict';

var sourceMap = require('source-map');
var convert = require('convert-source-map');

function _interopNamespaceDefault(e) {
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var convert__namespace = /*#__PURE__*/_interopNamespaceDefault(convert);

// @flow
function getGeneratorOpts(file) {
    return file.opts.generatorOpts ? file.opts.generatorOpts : file.opts;
}
// export function makeSourceMapGenerator(file) {
//     const generator = new SourceMapGenerator();
//     return generator;
// }
function makeSourceMapGenerator(file) {
    const generatorOpts = getGeneratorOpts(file);
    const filename = generatorOpts.sourceFileName;
    const generator = new sourceMap.SourceMapGenerator({
        file: filename,
        sourceRoot: generatorOpts.sourceRoot,
    });
    // console.log('root', generatorOpts.sourceRoot);
    generator.setSourceContent(filename, file.code);
    return generator;
}
function convertGeneratorToComment(generator) {
    return convert__namespace.fromObject(generator).toComment({ multiline: true });
}

Object.defineProperty(exports, 'SourceMapGenerator', {
    enumerable: true,
    get: function () { return sourceMap.SourceMapGenerator; }
});
exports.convertGeneratorToComment = convertGeneratorToComment;
exports.getGeneratorOpts = getGeneratorOpts;
exports.makeSourceMapGenerator = makeSourceMapGenerator;
//# sourceMappingURL=source-maps.js.map
